#include <stdio.h>
#include "returnValues.h"
#include "danStuff.h"
#include "interlin2.h"
#include "SSC8Spooler.h"

void cache0(float position);
void cache1(float position) ;
void cache2(float position);
void cache3(float position) ;
void cache4(float position);
void cache5(float position) ;

void motSync() ;
void playFile(char * filename) ;


SSC8Spooler_t  axii; // todo: fix this silly global
float pos[6];
int stepDelay;
axies2_t axies;
   
   
int main(void) {

  SSC8SpoolerInit(&axii);                      // initialize syste
  if (SSC8SpoolerOpenDevice(&axii, "/dev/ttyUSB0") != OK)  {
    printf("Failure to open port!\n");
    return 1;
  }
  if (SSC8SpoolerStartTransmitter(&axii) != OK) {    // start transmitter
    printf("Failure! \n");
    return 1;
  }

  axisInit( &axies, motSync );
  axisAdd(&axies, 0,  0, cache0);
  axisAdd(&axies, 0,  0, cache1);
  axisAdd(&axies, 0,  0, cache2);
  axisAdd(&axies, 0,  0, cache3);
  axisAdd(&axies, 0,  0, cache4);
  axisAdd(&axies, 0,  0, cache5); 
  
  
  axies.motionSteps = 40; // up the resolution
  SimotaniouslyLinearlyInterpolateMultiAxis( &axies );
  
  
  playFile("test.motion") ;  

  return 0;
}


void cache0(float position) {
  pos[0] = position;
}

void cache1(float position) {
  pos[1] = position;
}

void cache2(float position) {
  pos[2] = position;
}

void cache3(float position) {
  pos[3] = position;
}

void cache4(float position) {
  pos[4] = position;
}

void cache5(float position) {
  pos[5] = position;
}


void motSync() {
  usleep(stepDelay);  
  ServoSetTarget(&(axii.servos.servo[0]), pos[0]);  
  ServoSetTarget(&(axii.servos.servo[1]), pos[1]);  
  ServoSetTarget(&(axii.servos.servo[2]), pos[2]);  
  ServoSetTarget(&(axii.servos.servo[3]), pos[3]);  
  ServoSetTarget(&(axii.servos.servo[4]), pos[4]);  
  ServoSetTarget(&(axii.servos.servo[5]), pos[5]);    
}

void playFile(char * filename) {

   FILE *input;
   float lasttime, time, A, B, C, D, E, F;

 
   // read 6 numbers per line, ended with linefeed, prefixed with delta time
   
   if ((input = fopen(filename, "rt")) == NULL) {  //open text file 'param 1' w/ err chk 
      printf("Unable to open %s for input.\n", filename);
   }

   while (fscanf(input, "%f, %f, %f, %f, %f, %f, %f \n", &time, &A, &B, &C, &D, &E, &F) == 7) {
     printf("%-04g sec : %-05g, %-05g, %-05g, %-05g, %-05g, %-05g \n", time, A, B, C, D, E, F);   
     
     time *= 1000000;                  // change to us
     //stepDelay = time / 40.0;          // 40steps
     stepDelay = 30000;       
     axies.motionSteps = time / 30000;   
     axies.axii[0].target = A;
     axies.axii[1].target = B;
     axies.axii[2].target = C;
     axies.axii[3].target = D;
     axies.axii[4].target = E;
     axies.axii[5].target = F;
     SimotaniouslyLinearlyInterpolateMultiAxis( &axies );
   }     
   
   fclose(input);


}

















